<?php
    namespace cs174Besties\hw4\Controllers;
    use cs174Besties\hw4\models\Model;
    use cs174Besties\hw4\views\View;

    //The controller handles user input and controls the web app.
    class Controller{

        private $i;
        private $j;
        private $n;
        private $m;
        private $zoomedOut;
        private $model;

        //Initializes the model, coordinates, and zoomedOut
        function __construct($currentCoords){
            #currentCoords --> [i,j] or [i,j,n,m]
            $this->model = new Model();

            if($currentCoords == ""){
                $this->i = 0;
                $this->j = 0;
                $this->n = 0;
                $this->m = 0;
                $this->zoomedOut = True;
            }
            else{
                $this->i = $currentCoords[0];
                $this->j = $currentCoords[1];
                if(count($currentCoords) > 2){
                    $this->n = $currentCoords[2];
                    $this->m = $currentCoords[3];
                    $this->zoomedOut = False;
                }
                else{
                    $this->n = 1;
                    $this->m = 1;
                    $this->zoomedOut = True;
                }
                
            }
        }

        //Updates the coordinates when the right button is pressed
        function moveRight(){
            if($this->zoomedOut){
                $this->j += 1;
            }
            else{
                $this->m += 1;
                if($this->m == 4){
                    $this->m = 0;
                    $this->j += 1;
                }
            }
        }

        //Updates the coordinates when the left button is pressed
        function moveLeft(){
            if($this->zoomedOut){
                $this->j -= 1;
            }
            else{
                $this->m -= 1;
                if($this->m == -1){
                    $this->m = 3;
                    $this->j -= 1;
                }
            }
        }

        //Updates the coordinates when the down button is pressed
        function moveDown(){
            if($this->zoomedOut){
                $this->i += 1;
            }
            else{
                $this->n += 1;
                if($this->n == 4){
                    $this->n = 0;
                    $this->i += 1;
                }
            }
        }

        //Updates the coordinates when the up button is pressed
        function moveUp(){
            if($this->zoomedOut){
                $this->i -= 1;
            }
            else{
                $this->n -= 1;
                if($this->n == -1){
                    $this->n = 3;
                    $this->i -= 1;
                }
            }
        }

        //Toggles the zoomedOut boolean
        //Used for determining how to display the image
        function toggleZoom(){
            $this->zoomedOut = !$this->zoomedOut;
        }

        //Displays the image either zoomed in or zoomed out
        function displayPage(){
            $images = [];
            if($this->zoomedOut){
                $coords = $this->i.$this->j."";
                $images = $this->model->getIJImages($coords);
            }
            else{
                $coords = $this->i.$this->j.$this->n.$this->m."";
                $images = $this->model->getIJNMImages($coords);
            }
            $currentCoords = [$this->i,$this->j,$this->n,$this->m];
            $view = new View($images, $currentCoords, $this->zoomedOut);
            $view->render();
        }

        //Called from the index, this function is used to handle user input and
        //call the display method.
        function route($action){
            if($action == "Right"){
                $this->moveRight();
            }
            else if($action == "Left"){
                $this->moveLeft();
            }
            else if($action == "Up"){
                $this->moveUp();
            }
            else if($action == "Down"){
                $this->moveDown();
            }
            else if($action == "In" or $action == "Out"){
                $this->toggleZoom();
            }
            $this->displayPage();
        }
    }