<?php
    namespace cs174Besties\hw4\executables;

    //is this include statement allowed?
    include_once("../../vendor/autoload.php");

    use Monolog\Logger;
    use Monolog\Handler\StreamHandler;
    use Monolog\Handler\FirePHPHandler;
    
    // Initialize the logger
    $logger = new Logger('image_logger');
    
    // Add handlers
    $logger->pushHandler(new StreamHandler(__DIR__.'/image_viewer.log', Logger::INFO));
    $logger->pushHandler(new FirePHPHandler());
    
    // Logger is ready for use.
    $logger->info('Logger Created.');

    #Retrieve command-line arguments
    $image = $argv[1];
    $dirName = $argv[2];

    $allImage = null;

    #Create directory
    if(!is_dir("../".$dirName)){
        $dir = mkdir("../".$dirName);
    }

    #Creates the all.jpg image by resizing $image to 800px by 800px
    function makeAllImage(){
        global $image;
        global $dirName;
        global $allImage;
        global $logger;
        $all = imagecreatetruecolor(800, 800);
        $srcImage = imagecreatefromjpeg($image);
        $srcSize = getimagesize($image);
        imagecopyresampled($all, $srcImage, 0, 0, 0, 0, 800, 800, $srcSize[0], $srcSize[1]);
        imagejpeg($all, "../".$dirName."/all.jpg");
        $logger->info('all.jpeg has been saved.');
        $allImage = $all;
        imagedestroy($srcImage);
    }

    #Creates the blank.jpg image
    function blankTile(){
        global $dirName;
        global $logger;
        $blank = imagecreatetruecolor(200, 200);
        imagejpeg($blank, "../".$dirName."/blank.jpg");
        $logger->info('blank.jpeg has been saved.');
        imagedestroy($blank);
    }

    #Creates 16 200px by 200px subimages from the all.jpg image
    function ijTiles(){
        global $allImage;
        global $dirName;
        global $logger;
        for($i = 0; $i < 4; $i+=1){
            for($j = 0; $j < 4; $j+=1){
                $ijTemp = imagecreatetruecolor(200, 200);
                $iCoord = $j * 200;
                $jCoord = $i * 200;
                imagecopyresampled($ijTemp, $allImage, 0, 0, $iCoord, $jCoord, 200, 200, 200, 200);
                imagejpeg($ijTemp, "../".$dirName."/".$i.$j.".jpg");
                $logger->info($i.$j.'.jpeg has been saved.');
                imagedestroy($ijTemp);
            }
        }
    }

    #Creates 256 200px by 200px subimages from the all.jpg image
    function ijnmTiles(){
        global $allImage;
        global $dirName;
        global $logger;
        for($i = 0; $i < 4; $i+=1){
            for($j = 0; $j < 4; $j+=1){
                for($n = 0; $n < 4; $n+=1){
                    for($m = 0; $m < 4; $m+=1){
                        $ijnmTemp = imagecreatetruecolor(200, 200);
                        $inCoord = $j * 200 + $m * 50;
                        $jmCoord = $i * 200 + $n * 50;
                        imagecopyresampled($ijnmTemp, $allImage, 0, 0, $inCoord, $jmCoord, 200, 200, 50, 50);
                        imagejpeg($ijnmTemp, "../".$dirName."/".$i.$j.$n.$m.".jpg");
                        $logger->info($i.$j.$n.$m.'.jpeg has been saved.');
                        imagedestroy($ijnmTemp);
                    }
                }
            }
        }
    }
    makeAllImage();
    blankTile();
    ijTiles();
    ijnmTiles();
