<?php
    namespace cs174Besties\hw4\models;

    //The model handles the retrieval of the image tiles in the image maps
    class Model{

        //These image maps are used to easily retrieve the images surrounding a single tile
        private $ijMap;
        private $ijnmMap;

        //Initializes the image maps
        function __construct(){

            $this->ijMap = [];
            $this->ijnmMap = [];

            #ijMap creation
            $blankArray = [];
            for($i = 0; $i < 6; $i += 1){
                array_push($blankArray, "blank");
            }
            array_push($this->ijMap, $blankArray);
            for($i = 0; $i < 4; $i += 1){
                $row = [];
                for($j = -1; $j < 5; $j += 1){
                    if($j < 0 or $j > 3){
                        array_push($row, "blank");
                    }
                    else{
                        array_push($row, $i.$j."");
                    }
                }
                array_push($this->ijMap, $row);
            }
            array_push($this->ijMap, $blankArray);

            #ijnmMap creation
            $blankArray = [];
            for($i = 0; $i < 18; $i += 1){
                array_push($blankArray, "blank");
            }
            array_push($this->ijnmMap, $blankArray);
            for($i = 0; $i < 4; $i += 1){
                for($n = 0; $n < 4; $n += 1){
                    $row = [];
                    array_push($row, "blank");
                    for($j = 0; $j < 4; $j += 1){
                        for($m = 0; $m < 4; $m += 1){
                            array_push($row, $i.$j.$n.$m."");
                        }
                    }
                    array_push($row, "blank");
                    array_push($this->ijnmMap, $row);
                }
            }
            array_push($this->ijnmMap, $blankArray);

        }

        //Retirieves the list of ij images in order from top left to bottom right.
        //The center image is at index 4 in the array.
        function getIJImages($center){
            $centerIndex  = [0,0];
            for($i = 0; $i < 5; $i += 1){
                $row = $this->ijMap[$i];
                $j = array_search($center, $row);
                if($j){
                    $centerIndex  = [$i,$j];
                    break;
                }
            }
            $images = [$this->ijMap[$centerIndex[0]-1][$centerIndex[1]-1],$this->ijMap[$centerIndex[0]-1][$centerIndex[1]],$this->ijMap[$centerIndex[0]-1][$centerIndex[1]+1],
            $this->ijMap[$centerIndex[0]][$centerIndex[1]-1],$this->ijMap[$centerIndex[0]][$centerIndex[1]],$this->ijMap[$centerIndex[0]][$centerIndex[1]+1],
            $this->ijMap[$centerIndex[0]+1][$centerIndex[1]-1],$this->ijMap[$centerIndex[0]+1][$centerIndex[1]],$this->ijMap[$centerIndex[0]+1][$centerIndex[1]+1]
            ];
            for($i = 0; $i < 9; $i += 1){
                $images[$i] = "./src/resources/".$images[$i].".jpg";
            }
            return $images;
        }

        //Retirieves the list of ijnm images in order from top left to bottom right.
        //The center image is at index 4 in the array.
        function getIJNMImages($center){
            $centerIndex  = [0,0];
            for($i = 0; $i < 18; $i += 1){
                $row = $this->ijnmMap[$i];
                $j = array_search($center, $row);
                if($j){
                    $centerIndex  = [$i,$j];
                    break;
                }
            }
            $images = [$this->ijnmMap[$centerIndex[0]-1][$centerIndex[1]-1],$this->ijnmMap[$centerIndex[0]-1][$centerIndex[1]],$this->ijnmMap[$centerIndex[0]-1][$centerIndex[1]+1],
            $this->ijnmMap[$centerIndex[0]][$centerIndex[1]-1],$this->ijnmMap[$centerIndex[0]][$centerIndex[1]],$this->ijnmMap[$centerIndex[0]][$centerIndex[1]+1],
            $this->ijnmMap[$centerIndex[0]+1][$centerIndex[1]-1],$this->ijnmMap[$centerIndex[0]+1][$centerIndex[1]],$this->ijnmMap[$centerIndex[0]+1][$centerIndex[1]+1]
            ];
            for($i = 0; $i < 9; $i += 1){
                $images[$i] = "./src/resources/".$images[$i].".jpg";
            }
            return $images;

        }

    }