<?php
namespace cs174Besties\hw4\views;
use cs174Besties\hw4\views\helpers\Helpers;

//This class represents the web page and displays its contents
class View {
    public $helper;
    public $images;
    public $coordinates;//These are in list form -> [i,j,n,m]
    public $zoomedOut;       

    //Initializes the data fields.
    function __construct($images, $coordinates, $zoomedOut) {
        $this->helper = new Helpers();
        $this->images = $images;
        $this->coordinates = $coordinates;
        $this->zoomedOut = $zoomedOut;
    }

    //Renders the web page
    function render() {
        ?>
        <!DOCTYPE html>
        <head>
            <title>CS174 HW4</title>
            <meta charset="utf-8">
            <link rel="stylesheet" type="text/css" href="./src/styles/styles.css?<?php echo time(); ?>">
        </head>
        <body>
            <h1>Map Server</h1>

            <table style="width=100%;">
            <tbody>
                <tr>
                    <td class="buttonsPanel">
                    
                    <b><label for="coords">Coordinates</label></b>

                    <!-- This form is for coordinate input -->
                    <form id="pressGo" name="pressGo" action="./index.php" onsubmit="return validateForm()" method="post">
                        <input id="currentCoords" name="currentCoords" type="text" value=<?php
                            echo $this->helper->coordinatesToString($this->zoomedOut,$this->coordinates);
                        ?>>
                        <button id="goButton">GO</button>
                    </form>
                    <br/>
                    <!-- This form is for control buttons -->
                    <form id="moveButtons" name="moveButtons" action="./index.php" method="post"> 
                        <b><label for="zoom">Zoom:</label></b>
                        <!-- This hidden input is for submitting the current coordinates when the below submit buttons are pressed -->
                        <input type="hidden" name="currentCoords" value=<?php echo $this->helper->coordinatesToString($this->zoomedOut,$this->coordinates);?>/>

                        <!-- Displays the zoom in/out buttons -->
                        <input type="submit" name="action" value="In" <?php if ($this->zoomedOut) echo "enabled"; else echo "disabled";?>>
                        <input type="submit" name="action" value ="Out" <?php if ($this->zoomedOut) echo "disabled"; else echo "enabled";?>>

                        <!-- Displays the directional buttons in a table -->
                        <table class="arrowKeysTable">
                        <tr>    
                            <td></td>
                            <td><input type="submit" class="directionButton" value="Up" name="action"
                            <?php
                                if ($this->zoomedOut) {
                                    if ($this->coordinates[0] == 0) echo "disabled";
                                    else echo "enabled";
                                } else {
                                    if ($this->coordinates[2] == 0 and $this->coordinates[0] == 0) echo "disabled";
                                    else echo "enabled";
                                }
                            ?>
                            ></td>
                            <td></td>
                        </tr>
                        <tr>
                            <td><input type="submit" class="directionButton" value="Left" name="action"
                            <?php 
                                if ($this->zoomedOut) {
                                    if ($this->coordinates[1] == 0) echo "disabled";
                                    else echo "enabled";
                                } else {
                                    if ($this->coordinates[3] == 0 and $this->coordinates[1] == 0) echo "disabled";
                                    else echo "enabled";
                                }
                            ?>></td>
                            <td></td>
                            <td><input type="submit" class="directionButton" value="Right" name="action"
                            <?php
                                if ($this->zoomedOut) {
                                    if ($this->coordinates[1] == 3) echo "disabled";
                                    else echo "enabled";
                                } else {
                                    if ($this->coordinates[3] == 3 and $this->coordinates[1] == 3) echo "disabled";
                                    else echo "enabled";
                                }
                            
                            ?>></td>
                        </tr>
                        <tr>
                            <td></td>
                            <td><input type="submit" class="directionButton" value="Down" name="action"
                            <?php
                                if ($this->zoomedOut) {
                                    if ($this->coordinates[0] == 3) echo "disabled";
                                    else echo "enabled";
                                } else {
                                    if ($this->coordinates[2] == 3 and $this->coordinates[0] == 3) echo "disabled";
                                    else echo "enabled";
                                }

                            ?>></td>
                            <td></td>
                        </tr>
                    </form>
                    </table>
                    <!-- States instructions for using the web app -->
                    <p>
                    <b>--Instructions--</b>
                    <br/>
                    <br/>
                    1. In the src/executables folder of the webapp, run the
                    command "php TileMaker.php image_name.jpg resources". In the command, 
                    make sure to call the filename "resources" so the web app knows 
                    where to find the images.
                    <br/>
                    <br/>
                    2. Reload the page.
                    <br/>
                    <br/>
                    3. Have fun!
                    <br/>
                    <br/>
                    Note: Coordinates can only be in the form "i,j" or "i,j,n,m"
                    </p>

                    <!-- Displays the images in a table with 3 rows and 3 columns -->
                    </td>
                    <td class="imagesPanel">
                    <table class="imageTable">
                        <?php
                        $this->helper->displayImages($this->images);
                        ?>
                    </table>
                    </td>
                </tr>
            </tbody>
            </table>

            <script type="text/javascript">
            //Validates the user-inputted coordinates
            function validateForm() {
                var input = document.forms["pressGo"]["currentCoords"].value;
                
                // check that input has 2 or 4 characters
                var slicedArr = input.split(',');
                if (slicedArr.length != 2 && slicedArr.length != 4) {
                    alert("You must enter 2 or 4 comma separated integers. \ni.e. \"i,j\" or \"i, j, n, m\"")
                    return false;
                }

                // check that each integer is between 0 to 3
                for (var i = 0; i < slicedArr.length; i++) {
                    slicedArr[i] = parseInt(slicedArr[i], 10); // convert to decimal number
                    if (slicedArr[i] != 0 && slicedArr[i] != 1 && slicedArr[i] != 2 && slicedArr[i] != 3) {
                        alert("You must enter an integer value between 0 and 3");
                        return false;
                    }
                }
                return true;
            }
            </script>

        </body>
        </html>
        <?php
    }

}
